﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Imports System.Data.SqlClient, System.Data.Common

Public Class Form1

    Private Sub BtBooks_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtBooks.Click
        If SqlInjection(TxtAuthor.Text) Then
            MsgBox("النص الذي كتبته به كلمات أو حروف غير مسموح بها")
            Exit Sub
        End If

        ' إنشاء كائن اتصال وفتحه
        Dim Cn As New SqlConnection(My.Settings.BooksConStr)
        Cn.Open()

        ' إنشاء كائن أمر
        Dim Cmd As New SqlCommand
        Cmd.CommandType = CommandType.StoredProcedure
        Cmd.CommandText = "GetAuthorBooks"
        Cmd.Connection = Cn

        ' إنشاء معامل وإضافته إلى معاملات كائن الامر
        Dim P As New SqlParameter("@Author", SqlDbType.NVarChar, 20)
        P.Value = TxtAuthor.Text
        Cmd.Parameters.Add(P)

        ' تنفيذ الاستعلام والحصول على قارئ بيانات
        ' لاحظ أننا طلبنا إغلاق كائن الاتصال آليا عند إغلاق قارئ البيانات
        Dim Dr = Cmd.ExecuteReader(CommandBehavior.CloseConnection)

        TxtBooks.Clear()
        Do While Dr.Read
            TxtBooks.AppendText(Dr("Book") & vbCrLf)
        Loop
        Dr.Close()
    End Sub

    Function SqlInjection(ByVal Txt As String) As Boolean
        ' سنفحص النص لمعرفة إن كان يحتوي على أية نصوص مشبوهة تشبه الاستعلامات المدسوسة
        Txt = Txt.ToLower
        If Txt.Contains(";") Then Return True
        If Txt.Contains("'") Then Return True
        If Txt.Contains("--") Then Return True
        If Txt.Contains("/*") Then Return True
        If Txt.Contains("*/") Then Return True
        If Txt.Contains("drop") Then Return True
        If Txt.Contains("delete") Then Return True
        If Txt.Contains("update") Then Return True
        If Txt.Contains("insert") Then Return True
        If Txt.Contains("select") Then Return True
        If Txt.Contains("alter") Then Return True
        If Txt.Contains("create") Then Return True
        If Txt.Contains("xp_") Then Return True
        If Txt.Contains("execute") Then Return True
        If Txt.Contains("exec") Then Return True
        If Txt.Contains("sp_executesql") Then Return True
        If Txt.Contains(" aux ") Then Return True
        If Txt.Contains("clock$") Then Return True
        If Txt.Contains(" con ") Then Return True
        If Txt.Contains("config$") Then Return True
        If Txt.Contains(" nul ") Then Return True
        If Txt.Contains(" prn ") Then Return True
        If Txt.Contains("com1") Then Return True
        If Txt.Contains("com2") Then Return True
        If Txt.Contains("com3") Then Return True
        If Txt.Contains("com4") Then Return True
        If Txt.Contains("com5") Then Return True
        If Txt.Contains("com6") Then Return True
        If Txt.Contains("com7") Then Return True
        If Txt.Contains("com8") Then Return True
        If Txt.Contains("lpt1") Then Return True
        If Txt.Contains("lpt2") Then Return True
        If Txt.Contains("lpt3") Then Return True
        If Txt.Contains("lpt4") Then Return True
        If Txt.Contains("lpt5") Then Return True
        If Txt.Contains("lpt6") Then Return True
        If Txt.Contains("lpt7") Then Return True
        If Txt.Contains("lpt8") Then Return True
        Return False
    End Function

End Class
