﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Public Class Form1

    Class Student
        Public Property ID As Integer
        Public Property Age As Integer
        Public Property Name As String
    End Class

    Dim Std() As Student = {New Student With {.ID = 1, .Age = 15, .Name = "Ahmad"},
                                             New Student With {.ID = 2, .Age = 16, .Name = "Hany"},
                                             New Student With {.ID = 3, .Age = 12, .Name = "Shrief"},
                                             New Student With {.ID = 4, .Age = 11, .Name = "Wael"},
                                             New Student With {.ID = 5, .Age = 14, .Name = "Mahmood"}}

    Dim Bm As BindingManagerBase = Me.BindingContext(Std)

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        TxtId.DataBindings.Add("Text", Std, "Id")
        TxtAge.DataBindings.Add("Text", Std, "Age")
        TxtName.DataBindings.Add("Text", Std, "Name")

        AddHandler Bm.PositionChanged, AddressOf Bm_PositionChanged
    End Sub

    Private Sub ChkBind_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChkBind.CheckedChanged
        If ChkBind.Checked Then
            Me.BindingContext(Std).ResumeBinding()
            TxtPos.Text = 0
        Else
            Me.BindingContext(Std).SuspendBinding()
        End If

    End Sub

    Private Sub BtFirst_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtFirst.Click
        Bm.Position = 0
    End Sub

    Private Sub BtPrevious_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtPrevious.Click
        If Bm.Position > 0 Then
            Bm.Position -= 1
        Else
            Bm.Position = Bm.Count - 1
        End If
    End Sub

    Private Sub BtLast_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtLast.Click
        Bm.Position = Bm.Count - 1
    End Sub

    Private Sub BtNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtNext.Click
        If Bm.Position < Bm.Count - 1 Then
            Bm.Position += 1
        Else
            Bm.Position = 0
        End If
    End Sub

    Private Sub Bm_PositionChanged(ByVal Sender As Object, ByVal e As EventArgs)
        TxtPos.Text = Bm.Position
    End Sub

    Private Sub TxtPos_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TxtPos.KeyPress
        Select Case e.KeyChar
            Case Chr(Keys.Enter)
                Bm.Position = TxtPos.Text
                ' قد يكتب المستخدم رقم خانة غير صحيحة، وفي هذه الحالة سيتم تصحيح الموضع تلقائيا
                ' لهذا نحتاج إلى عرض الموضع الفعلي في مربع النص مرة آخرى
                ' صحيح أن حدث تغير الموضع سيصحح قيمة مربع النص أول مرة، 
                ' ولكن كتابة المستخدم لقيمة خاطئة مرة أخرى على التوالي
                ' سيجعل خاصية الموضع تأخذ نفس القيمة السابقة ولن ينطلق حدث تغير الموضع 
                ' لهذا سنحل نحن هذه المشكلة بتحديث مربع النص بأنفسنا
                TxtPos.Text = Bm.Position
            Case "0" To "9", Chr(Keys.Back)
                ' الحروف المسموح بكتابتها فقط
            Case Else
                e.Handled = True
        End Select
    End Sub

End Class
