﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim Ds As New DataSet
        Ds.DataSetName = "قاعدة بيانات الكتب"
        DaAuthors.Fill(Ds)
        DaBooks.Fill(Ds)
        ' لا تنس إنشاء العلاقة في مجموعة البيانات لأنها لا تنشأ آليا
        Dim Rel = New DataRelation("كتب المؤلف", Ds.Tables("Authors").Columns("ID"), Ds.Tables("Books").Columns("AuthorID"))
        Ds.Relations.Add(Rel)
        DGAuthors.DataSource = Ds.Tables("Authors")
        DGAuthors.Columns("RowVersion").Visible = False
        Dim Col As New DataGridViewButtonColumn
        Col.Text = "عرض كتب المؤلف"
        Col.UseColumnTextForButtonValue = True
        DGAuthors.Columns.Add(Col)

    End Sub

    Private Sub DGAuthors_CellContentClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DGAuthors.CellContentClick
        If TypeOf DGAuthors.CurrentCell Is DataGridViewButtonCell Then
            Dim DR = CType(DGAuthors.Rows(e.RowIndex).DataBoundItem, DataRowView)
            If DR Is Nothing Then Exit Sub
            FrmBooks.LbAuthor.Text = "كتب " & DR("Author") & ": "
            FrmBooks.DGAuthorBooks.DataSource = DR.CreateChildView("كتب المؤلف")
            FrmBooks.ShowDialog()
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        For Each R As DataGridViewRow In DGAuthors.Rows
            R.Selected = Not R.Selected
        Next
    End Sub

    Private Sub DGAuthors_UserDeletingRow(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewRowCancelEventArgs) Handles DGAuthors.UserDeletingRow
        If MsgBox("هل تريد حذف هذا الصف", MsgBoxStyle.OkCancel) = MsgBoxResult.Cancel Then
            e.Cancel = True
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim SelRows = DGAuthors.SelectedRows
        For Each R As DataGridViewRow In SelRows
            R.Selected = False
        Next
        DGAuthors.Rows(0).Selected = True
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        DGAuthors.ClearSelection()
        DGAuthors.Rows(1).Selected = True
    End Sub
End Class
