﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Public Class Form1

    Dim Ds As New DataSet


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Ds.Namespace = "My Project"
        Ds.Prefix = "Authors-Books"
        Ds.DataSetName = "DsBooks"
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' حفظ أي تغيير لم يحفظه المستخدم
        ' قبل إعادة إنعاش مجموعة البيانات
        If Ds.HasChanges() Then BtUpdate.PerformClick()
        ' محو أية بيانات موجودة حاليا لمنع اي تداخل
        Ds.Reset()

        DaAuthors.FillSchema(Ds, SchemaType.Mapped)
        DaAuthors.Fill(Ds)
        DaBooks.FillSchema(Ds, SchemaType.Mapped)
        DaBooks.Fill(Ds)

        Dim TblAuthors = Ds.Tables("Authors")
        If Ds.Relations.IndexOf("AuthorsBooks") = -1 Then
            Ds.Relations.Add("AuthorsBooks", TblAuthors.Columns("ID"),
                                           Ds.Tables("Books").Columns("AuthorID"))
        End If
        DgAuthors.DataSource = TblAuthors
        DgAuthors.Columns("RowVersion").Visible = False
    End Sub

    Private Sub DgAuthors_RowEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DgAuthors.RowEnter
        Dim TblAuthors = Ds.Tables("Authors")
        Dim RowView = TblAuthors.DefaultView(e.RowIndex)
        Dim DvBooks As DataView = RowView.CreateChildView("AuthorsBooks")
        DgBooks.DataSource = DvBooks
        'DgBooks.Columns("AuthorID").Visible = False
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtUpdate.Click
        DaBooks.Update(Ds)
        DaAuthors.Update(Ds)
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Ds.WriteXmlSchema("C:\DsBooksSchema.xml")
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Ds.WriteXml("C:\DsBooksData.xml", XmlWriteMode.WriteSchema)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Ds.Reset()
        Ds.ReadXmlSchema("C:\DsBooksSchema.xml")
        DgAuthors.DataSource = Ds.Tables("Authors")
        DgAuthors.Columns("RowVersion").Visible = False
    End Sub


    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Ds.Reset()
        Ds.ReadXml("C:\DsBooksData.xml", XmlReadMode.ReadSchema)
        ' قبول التغييرات حتى لا يتم اعتبار السجلات التي تم تحميلها جديدة
        Ds.AcceptChanges()
        DgAuthors.DataSource = Ds.Tables("Authors")
        DgAuthors.Columns("RowVersion").Visible = False
    End Sub

    Private Sub DgAuthors_UserDeletingRow(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewRowCancelEventArgs) Handles DgAuthors.UserDeletingRow
        Dim BooksRows = DgBooks.Rows

        ' محاولة حذف السجل الجديد ستعطي خطأ
        Dim LastRowIndex As Integer
        If DgBooks.AllowUserToAddRows Then
            ' يوجد سجل جديد.. رقم آخر سجل يمكن حذفه يقل باثنين عن عدد السجلات
            ' تذكر أن رقم أول سجل هو 0
            LastRowIndex = BooksRows.Count - 2
        Else ' لا يوجد سجل.. رقم آخر سجل يمكن حذفه تقل بواحد عن عدد السجلات
            LastRowIndex = BooksRows.Count - 1
        End If

        ' يجب حذف السجلات من آخر سجل إلى أول سجل، لأن حذف السجل يغير ارقام السجلات التالية له
        ' أو يمكنك الاستمرار في حذف أول سجل إلى أن تصير مجموعة الصفوف فارغة
        For I = LastRowIndex To 0 Step -1
            BooksRows.RemoveAt(I)
        Next
    End Sub

    Private Sub Button2_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim R = Ds.CreateDataReader()
        Do
            For i = 0 To R.FieldCount - 1
                Console.Write(R.GetName(i) & vbTab)
            Next
            Console.WriteLine()
            Console.WriteLine("------------------------------------------------")
            Do While R.Read
                For i = 0 To R.FieldCount - 1
                    Console.Write(R(i).ToString & vbTab)
                Next
                Console.WriteLine()
            Loop
            Console.WriteLine()
        Loop While R.NextResult
    End Sub
End Class
