﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Imports System.Data.Common
Public Class Form1

    Dim DbBooks As MyDbConnector

    Private Sub BtAddAuthor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtAddAuthor.Click
        Dim SQL = "INSERT INTO Authors (Author, CountryID, About)" &
                            " VALUES (@Author, 21, @About)"
        Dim Params = {{"@Author", TxtAuthor.Text}, {"@About", TxtAbout.Text}}
        If DbBooks.ExcuteCommand(SQL, Params) Then
            TxtAuthor.Clear()
            TxtAbout.Clear()
        End If
    End Sub

    Private Sub TxtAuthor_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TxtAuthor.TextChanged
        BtAddAuthor.Enabled = (TxtAuthor.Text.Trim <> "")
    End Sub

    Private Sub Button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        MsgBox(DbBooks.GetValue("SELECT COUNT(Author) FROM Authors", Nothing))
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim SQL = "SELECT Book FROM Books, Authors" &
                                " WHERE AuthorID =  Authors.ID AND Author = @Author"
        Dim P = {{"@Author", TxtAuthor.Text.Trim}}

        Dim R = DbBooks.GetReader(SQL, P)
        ShowResult(R)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        ' سنحصل على الكتب هذه المرة باستدعاء الإجراء المخزن
        Dim R = DbBooks.GetReader("GetAuthorBooks", {{"@Author", TxtAuthor.Text.Trim}})
        ShowResult(R)

    End Sub

    Sub ShowResult(ByVal R As dbDataReader)
        If R IsNot Nothing Then
            TxtBooks.Clear()
            Do While R.Read
                TxtBooks.AppendText(R(0) & vbCrLf)
            Loop
            R.Close()
        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim T = DbBooks.GetTable("SELECT * FROM Authors")
        FrmGrid.Grd.DataSource = T
        FrmGrid.ShowDialog()
    End Sub

    Private Sub RdSql_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RdSql.CheckedChanged, RdAccess.CheckedChanged
        If RdSql.Checked Then
            DbBooks = New MyDbConnector(My.Settings.BooksMdfConStr, MyDbConnector.Providers.SqlServer)
        Else
            DbBooks = New MyDbConnector(My.Settings.BooksMdbConStr, MyDbConnector.Providers.OleDb)
        End If
    End Sub

End Class
