﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Imports System.Data.SqlTypes

Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim Sb1 As New SqlBinary({100, 220, 3})
        Dim Sb2 As SqlBinary = {1, 0, 2}

        MsgBox(Sb1.Item(0)) ' 100
        MsgBox(Sb1(1)) ' 220
        MsgBox(Sb1.Length) ' 3
        MsgBox(Sb1 = Sb2) ' False

        MsgBox((Sb1 = SqlBinary.Null).ToString) ' Null

        Dim Sb = SqlBinary.Add(Sb1, Sb2)
        ' الجملة التالية مكافئة للسابقة
        ' Dim Sb = Sb1 + Sb2
        ' Dim Sb = SqlBinary.Concat(Sb1, Sb2)

        TextBox1.Clear()
        For Each I In Sb.Value
            TextBox1.AppendText(I & vbCrLf)
        Next

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim Sb As New SqlBoolean(True)
        MsgBox(Sb.IsFalse) ' False
        If Not Sb.IsNull Then
            MsgBox(Sb.ByteValue) ' 1
            MsgBox(Sb.Value) ' True
            MsgBox((Not Sb).Value) ' False
        End If

        Sb = SqlBoolean.Parse("false")
        Dim B As Byte = Sb.ToSqlByte
        MsgBox(B.ToString) ' 0

        Dim Sb1 As SqlBoolean = "true"
        Dim B1 As SqlByte = Sb1
        MsgBox(B1.ToString) ' 1

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim Sd As New SqlDecimal(100000.0000001)
        MsgBox(Sd.Precision)
        MsgBox(Sd.Scale)
        MsgBox(Sd.Value)
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim Sc As New SqlChars("This is a test")
        MsgBox(Sc.Item(0))
        Sc(2) = "X"c
        MsgBox(Sc(2))
        MsgBox(Sc.Length) ' 14
        MsgBox(Sc.MaxLength) ' 14
        Sc.SetLength(10)
        MsgBox(Sc.Length) ' 10
        MsgBox(Sc.MaxLength) ' 14
        Sc.SetLength(12)

        MsgBox(Sc.Storage.ToString)

        Dim C(4) As Char
        Sc.Read(3, C, 0, 5)
        MsgBox("'" & C & "'")

        Dim X() As Char = {"A"c, "B"c, "C"c, "D"c, "E"c}
        Sc.Write(3, X, 0, 5)
        MsgBox(Sc.Value)
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim LCID = System.Globalization.CultureInfo.
            CurrentCulture.LCID
        Dim Ss1 As New SqlString("محمد", LCID)
        Dim Ss2 As New SqlString(" محمود", LCID)
        Dim Ss3 = Ss1 + Ss2
        MsgBox(Ss3.Value) ' محمد محمود

    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim Sb As New SqlBytes({100, 20, 200, 10})
        MsgBox(Sb.Item(0)) ' 100
        Sb(2) = 156
        MsgBox(Sb(2)) ' 156
        MsgBox(Sb.Length) ' 4
        MsgBox(Sb.MaxLength) ' 4
        Sb.SetLength(3)
        MsgBox(Sb.Length) ' 3
        ' جرب تحويل الجملةى التالية إلى تعليق،
        ' وانظر تأثيرها على النتائج الظاهرة في مربع النص
        MsgBox(Sb.MaxLength) ' 4
        Sb.SetLength(4)
        MsgBox(Sb.Storage.ToString)
        Dim B(3) As Byte
        Sb.Stream.Read(B, 0, Sb.Length)
        TextBox1.Clear()
        For Each I In B
            TextBox1.AppendText(I & vbCrLf)
        Next
    End Sub
End Class
