﻿Partial Class DsAuthorsBooks
    Partial Class AuthorsDataTable

        Dim TempDs As DsAuthorsBooks

        Private Sub AuthorsDataTable_AuthorsRowDeleted(ByVal sender As Object, ByVal e As AuthorsRowChangeEvent) Handles Me.AuthorsRowDeleted
            If TempDs IsNot Nothing AndAlso TempDs.Authors.Count > 0 Then
                ' إعادة السجل المحذوف بدمج السجل الاحتياطي
                Me.Merge(TempDs.Authors)
                ' امح السجل من المجموعة الاحتياطية
                ' هذا يمنع أي مشكلة مع عملية الحذف التالية
                ' تذكر إن إنشاء نسخة جديدة من مجموعة البيانات لا يتم إلا إذا طلب المستخدم إلغاء عملية الحذف
                ' أما إذا طلب إتمام عملية الحذف، فستظل مجموعة البيانات تحمل نفس بياناتها القديمة
                ' لهذا يجب أن نمحو أي سجل موجود فيها الىن لضمان إفراغها دائما
                TempDs.Clear()
            End If
        End Sub

        Private Sub AuthorsDataTable_AuthorsRowDeleting(ByVal sender As Object, ByVal e As AuthorsRowChangeEvent) Handles Me.AuthorsRowDeleting
            If MsgBox("هل تريد حذف هذا السجل؟", MsgBoxStyle.OkCancel) = MsgBoxResult.Cancel Then
                ' إنشاء نسخة جديدة من مجموعة البيانات الاحتياطية
                ' هذا يمحو أي سجلات سابقة أضفناها إلى النسخة القديمة
                TempDs = New DsAuthorsBooks
                ' نسخ السجل إلى المجموعة الاحتياطية قبل حذفه
                TempDs.Merge({e.Row})
            End If
        End Sub

        Private Sub AuthorsDataTable_ColumnChanging(ByVal sender As Object, ByVal e As System.Data.DataColumnChangeEventArgs) Handles Me.ColumnChanging
            If e.Column Is AuthorColumn AndAlso e.ProposedValue = "" Then
                e.ProposedValue = e.Row(e.Column)
            End If
        End Sub
    End Class

End Class
