﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Public Class Form1

    Dim ViewSettings As DataViewSetting
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        TaAuthors.Fill(Ds.Authors)
        TaBooks.Fill(Ds.Books)
        TaClasses.Fill(Ds.Classes)
        TaCountries.Fill(Ds.Countries)
        TaSales.Fill(Ds.Sales)
        TaPublishers.Fill(Ds.Publishers)

        For Each Tbl As DataTable In Ds.Tables
            LstTables.Items.Add(Tbl)
        Next
        LstTables.DisplayMember = "TableName"
        LstTables.SelectedIndex = 0
        LstOp.SelectedIndex = 0
        LstSortOrder.SelectedIndex = 0

    End Sub

    Private Sub LstTables_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LstTables.SelectedIndexChanged
        Dim T As DataTable = LstTables.SelectedItem
        Dgv.DataSource = T

        ViewSettings = Ds.DefaultViewManager.DataViewSettings(T)
        LstField.Items.Clear()
        LstSort.Items.Clear()
        LstField.Items.Add("(None)")
        LstSort.Items.Add("(None)")
        For Each Col As DataColumn In T.Columns
            LstField.Items.Add(Col.ColumnName)
            LstSort.Items.Add(Col.ColumnName)
        Next
        LstField.SelectedIndex = 0
        LstSort.SelectedIndex = 0
    End Sub

    Private Sub Dgv_DataError(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewDataErrorEventArgs) Handles Dgv.DataError
        e.Cancel = True
    End Sub

    Private Sub LstField_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LstField.SelectedIndexChanged
        LstOp.Enabled = (LstField.SelectedIndex <> 0)
        TxtValue.Enabled = LstOp.Enabled
    End Sub

    Private Sub LstSort_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LstSort.SelectedIndexChanged
        LstSortOrder.Enabled = (LstSort.SelectedIndex <> 0)
        ViewSettings.ApplyDefaultSort = Not LstSortOrder.Enabled
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If LstField.SelectedIndex = 0 Then
            ViewSettings.RowFilter = ""
        Else
            ViewSettings.RowFilter = LstField.Text & " " & LstOp.Text & " " & TxtValue.Text.Trim
        End If

        If LstSort.SelectedIndex = 0 Then
            ViewSettings.Sort = ""
        Else
            ViewSettings.Sort = LstSort.Text & " " & If(LstSortOrder.SelectedIndex = 0, "ASC", "DESC")
        End If

        Dim Dv = ViewSettings.DataViewManager.CreateDataView(ViewSettings.Table)
        Dgv.DataSource = Dv


    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim Dv As New DataView(Ds.Books, "Parent(FK_Books_Authors).Author = 'توفيق الحكيم'", "Book", DataViewRowState.CurrentRows)
        Dgv.DataSource = Dv
    End Sub
End Class
