﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Imports System.Data.Common
Imports System.Data.SqlClient
Imports System.Configuration

Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim SB As New System.Text.StringBuilder(
            "Data Source = .\SQLEXPRESS;")
        DbConnectionStringBuilder.AppendKeyValuePair(SB,
                    "AttachDbFilename", "C:\Books.mdf")
        DbConnectionStringBuilder.AppendKeyValuePair(SB,
                   "Integrated Security", "True")
        MsgBox(SB.ToString)

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim ConStrB1 As New DbConnectionStringBuilder
        ConStrB1.Add("Data Source", ".\SQLEXPRESS")
        ConStrB1.Add("AttachDbFilename", "C:\Books.mdf")
        ConStrB1.Add("Integrated Security", "True")

        Dim ConStrB2 As New SqlConnectionStringBuilder
        ConStrB2.Add("AttachDbFilename", "C:\Books.mdf")
        ConStrB2.Add("Integrated Security", "True")
        ConStrB2.Add("Data Source", ".\SQLEXPRESS")

        MsgBox(ConStrB1.ToString)
        MsgBox(ConStrB2.ConnectionString)
        MsgBox(ConStrB1.EquivalentTo(ConStrB2))
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim CSB As New DbConnectionStringBuilder()
        CSB.Add("AttachDbFilename", "C:\Books.mdf")
        MsgBox(CSB.ShouldSerialize("AttachDbFilename")) ' True
        MsgBox(CSB.ContainsKey("AttachDbFilename")) ' True

        MsgBox(CSB.ShouldSerialize("Data Source")) ' False
        MsgBox(CSB.ContainsKey("Data Source")) ' False

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim CSB As New DbConnectionStringBuilder()
        CSB.Add("AttachDbFilename", "C:\Books.mdf")

        If CSB.ContainsKey("AttachDbFilename") Then
            MsgBox(CSB("AttachDbFilename")) ' C:\Books.mdf
        Else
            MsgBox("المفتاح غير موجود")
        End If

        Dim Value As Object
        If CSB.TryGetValue("AttachDbFilename", Value) Then
            MsgBox(CSB("AttachDbFilename")) ' C:\Books.mdf
        Else
            MsgBox("المفتاح غير موجود")
        End If

        If CSB.TryGetValue("", Value) Then
            MsgBox(CSB("Data Source")) ' C:\Books.mdf
        Else
            MsgBox("المفتاح غير موجود")
        End If
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim CnStrBldr As New SqlConnectionStringBuilder
        CnStrBldr.DataSource = ".\SQLEXPRESS"
        CnStrBldr.InitialCatalog = "Books"
        CnStrBldr.IntegratedSecurity = True
        Dim CnStr = CnStrBldr.ConnectionString
        MsgBox(CnStr)

    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim CnStrSett = ConfigurationManager.ConnectionStrings
        For Each CnStr As ConnectionStringSettings In CnStrSett
            MsgBox("Name: " & CnStr.Name & vbCrLf &
                   "ProviderName: " & CnStr.ProviderName & vbCrLf &
                   "ConnectionString: " & CnStr.ConnectionString)
        Next

        MsgBox(CnStrSett("ConStrBuilder.My.MySettings.BooksConStr").ToString)
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        MsgBox(My.Settings.BooksConStr)
    End Sub

End Class
