﻿Public Class FrmGrades

    Private Sub DgGrades_CellEndEdit(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DgGrades.CellEndEdit
        ShowSum()
    End Sub

    Sub ShowSum()
        Dim Dv As DataView = DgGrades.DataSource
        Dim Sum = 0
        For Each R As DataRowView In Dv
            Dim Grade = R("Grade")
            If Grade IsNot DBNull.Value Then Sum += Grade
        Next
        LbSum.Text = "المجموع = " & Trim(Sum)
        FrmStudents.DgStudents.CurrentRow.Cells("SumCol").Value = Trim(Sum)
    End Sub

    Private Sub DgGrades_DataError(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewDataErrorEventArgs) Handles DgGrades.DataError
        Beep()
        e.Cancel = True
    End Sub

    Private Sub FrmGrades_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LstNames.DataSource = FrmStudents.DsStudents.Students
        LstNames.DisplayMember = "Name"
        LstNames.SelectedIndex = FrmStudents.DgStudents.CurrentRow.Index
    End Sub

    Private Sub LstNames_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LstNames.SelectedIndexChanged
        Dim Idx = LstNames.SelectedIndex
        If Idx = -1 Then Exit Sub
        Try
            FrmStudents.DgStudents.CurrentCell = FrmStudents.DgStudents(0, Idx)
            FrmStudents.ShowGrades(Idx)
        Catch ex As Exception

        End Try

    End Sub
End Class