﻿
Public Class TreeCell
    Inherits DataGridViewTextBoxCell

    Public Overrides Sub InitializeEditingControl(ByVal rowIndex As Integer, _
        ByVal initialFormattedValue As Object, _
        ByVal dataGridViewCellStyle As DataGridViewCellStyle)

        ' استدعاء الوسيلة الخاصة بالفئة الأم لتنفيذ أية مهام تؤديها
        MyBase.InitializeEditingControl(rowIndex, initialFormattedValue, _
            dataGridViewCellStyle)

        Dim ctl As TreeEditingControl = CType(DataGridView.EditingControl, TreeEditingControl)
        If ctl.Nodes.Count = 0 Then ctl.Nodes.Add("A", "A").Nodes.Add("B", "B").Nodes.Add("C", "C")

        Try
            ' عرض قيمة الخانة الحالية في الشجرة
            ctl.EditingControlFormattedValue = Me.Value
        Catch ex As Exception

        End Try

    End Sub

    Public Overrides ReadOnly Property EditType() As Type
        Get
            ' Return the type of the editing contol that TreeCell uses.
            Return GetType(TreeEditingControl)
        End Get
    End Property

    Public Overrides ReadOnly Property ValueType() As Type
        Get
            ' Return the type of the value that TreeCell contains.
            Return GetType(String)
        End Get
    End Property

    Public Overrides ReadOnly Property DefaultNewRowValue() As Object
        Get
            Return ""
        End Get
    End Property

End Class