﻿
Public Class TreeComboCell
    Inherits DataGridViewTextBoxCell

    Public Overrides Sub InitializeEditingControl(ByVal rowIndex As Integer, _
        ByVal initialFormattedValue As Object, _
        ByVal dataGridViewCellStyle As DataGridViewCellStyle)

        ' استدعاء الوسيلة الخاصة بالفئة الأم لتنفيذ أية مهام تؤديها
        MyBase.InitializeEditingControl(rowIndex, initialFormattedValue, _
            dataGridViewCellStyle)

        Dim ctl As TreeComboEditingControl = CType(DataGridView.EditingControl, TreeComboEditingControl)
        If ctl.MyTreeView.Nodes.Count = 0 Then ctl.MyTreeView.Nodes.Add("A", "A").Nodes.Add("B", "B").Nodes.Add("C", "C")

        Try
            ' عرض قيمة الخانة الحالية في الشجرة
            ctl.EditingControlFormattedValue = Me.Value
        Catch ex As Exception

        End Try

    End Sub

    Public Overrides ReadOnly Property EditType() As Type
        Get
            Return GetType(TreeComboEditingControl)
        End Get
    End Property

    Public Overrides ReadOnly Property ValueType() As Type
        Get
            Return GetType(String)
        End Get
    End Property

    Public Overrides ReadOnly Property DefaultNewRowValue() As Object
        Get
            Return ""
        End Get
    End Property

End Class