﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Public Class Form1

    Const RowsNo = 10
    Private Sub AuthorsBindingNavigatorSaveItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AuthorsBindingNavigatorSaveItem.Click
        Me.Validate()
        Me.AuthorsBindingSource.EndEdit()
        Me.TableAdapterManager.UpdateAll(Me.BooksDataSet)

    End Sub

    Private Sub FillToolStripButton_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FillToolStripButton.Click
        Try
            Me.AuthorsTableAdapter.Fill(Me.BooksDataSet.Authors, CType(StartIDToolStripTextBox.Text, Integer), CType(EndIDToolStripTextBox.Text, Integer))
        Catch ex As System.Exception
            System.Windows.Forms.MessageBox.Show(ex.Message)
        End Try

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim MaxID = AuthorsTableAdapter.GetMaxID
        Dim PagesNo As Integer = Math.Ceiling(MaxID / RowsNo)
        Dim PrvLnk = LnkPage1
        For I = 2 To PagesNo
            Dim Lnk As New LinkLabel
            Me.Controls.Add(Lnk)
            Lnk.Visible = True
            Lnk.Text = I
            Lnk.Font = PrvLnk.Font
            Lnk.AutoSize = True
            Lnk.Location = PrvLnk.Location - New Point(Lnk.Width + 10, 0)
            Lnk.Anchor = PrvLnk.Anchor
            AddHandler Lnk.LinkClicked, AddressOf LnkPage1_LinkClicked
            PrvLnk = Lnk
        Next
        LnkPage1_LinkClicked(LnkPage1, New LinkLabelLinkClickedEventArgs(Nothing))
    End Sub

    Private Sub LnkPage1_LinkClicked(ByVal sender As System.Object, ByVal e As LinkLabelLinkClickedEventArgs) Handles LnkPage1.LinkClicked
        Dim Lnk = CType(sender, LinkLabel)
        Dim StartID As Integer = RowsNo * (CInt(Lnk.Text) - 1) + 1
        Try
            Me.AuthorsTableAdapter.Fill(BooksDataSet.Authors, StartID, StartID + RowsNo)
            Me.BooksTableAdapter.Fill(BooksDataSet.Books, StartID, StartID + RowsNo)
        Catch ex As System.Exception
            System.Windows.Forms.MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub AuthorsDataGridView_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles AuthorsDataGridView.CellContentClick
        If AuthorsDataGridView.Columns(e.ColumnIndex) Is ColBooks Then
            Dim DR = CType(AuthorsDataGridView.Rows(e.RowIndex).DataBoundItem, DataRowView)
            If DR Is Nothing Then Exit Sub
            FrmBooks.LbAuthor.Text = "كتب " & DR("Author") & ": "
            FrmBooks.DGAuthorBooks.DataSource = DR.CreateChildView("FK_Books_Authors")
            FrmBooks.ShowDialog()
        End If
    End Sub

    Private Sub EndIDToolStripTextBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles EndIDToolStripTextBox.KeyPress
        If e.KeyChar = Chr(13) Then
            FillToolStripButton.PerformClick()
        End If
    End Sub
End Class
