﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Public Class Form1

    Const RowsNo = 2
    Const MaxLinks = 5
    Dim PageLinks As New List(Of LinkLabel)
    Dim CurLink As LinkLabel
    Dim FirstPageNo As Integer = 1
    Dim PagesNo As Integer

    Private Sub AuthorsBindingNavigatorSaveItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AuthorsBindingNavigatorSaveItem.Click
        Me.Validate()
        Me.AuthorsBindingSource.EndEdit()
        Me.TableAdapterManager.UpdateAll(Me.BooksDataSet)
        ' تحديث عدد الصفحات
        Dim RowsCount As Double = AuthorsTableAdapter.GetCount / RowsNo
        PagesNo = Math.Ceiling(RowsCount)
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        CurLink = LnkPage1
        Dim RowsCount As Double = AuthorsTableAdapter.GetCount / RowsNo
        PagesNo = Math.Ceiling(RowsCount)
        PageLinks.Add(LnkPage1)
        Dim PrvLnk = LnkPage1
        For I = 2 To Math.Min(PagesNo, MaxLinks)
            Dim Lnk As New LinkLabel
            Me.Controls.Add(Lnk)
            Lnk.Visible = True
            Lnk.Text = I
            Lnk.Font = PrvLnk.Font
            Lnk.AutoSize = True
            Lnk.Location = PrvLnk.Location - New Point(Lnk.Width + 10, 0)
            Lnk.Anchor = PrvLnk.Anchor
            AddHandler Lnk.LinkClicked, AddressOf LnkPage1_LinkClicked
            PrvLnk = Lnk
            PageLinks.Add(PrvLnk)
        Next
        LnkNext.Location = PrvLnk.Location - New Point(LnkNext.Width + 10, 0)
        LnkPage1_LinkClicked(LnkPage1, New LinkLabelLinkClickedEventArgs(Nothing))
    End Sub

    Private Sub LnkPage1_LinkClicked(ByVal sender As System.Object, ByVal e As LinkLabelLinkClickedEventArgs) Handles LnkPage1.LinkClicked
        Dim Lnk = CType(sender, LinkLabel)
        Dim I = CInt(Lnk.Text)
        LnkPrev.Enabled = (I > 1)
        LnkNext.Enabled = (I < PagesNo)
        Dim FirstAuthorNo As Integer = RowsNo * (I - 1) + 1
        Try
            If FirstAuthorNo = 1 Then
                Me.AuthorsTableAdapter.FillFirstPage(BooksDataSet.Authors, RowsNo)
                Me.BooksTableAdapter.FillFirstPage(BooksDataSet.Books, RowsNo)
            Else
                Me.AuthorsTableAdapter.Fill(BooksDataSet.Authors, RowsNo, FirstAuthorNo)
                Me.BooksTableAdapter.Fill(BooksDataSet.Books, RowsNo, FirstAuthorNo)
            End If

            ' إعادة الرابط السابق إلى وضعه الأصلي
            CurLink.Enabled = True
            CurLink.Font = New Font(CurLink.Font, FontStyle.Regular)

            ' تمييز الرابط الحالي
            Lnk.Enabled = False
            Lnk.Font = New Font(Lnk.Font, FontStyle.Bold)

            CurLink = Lnk

        Catch ex As System.Exception
            System.Windows.Forms.MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub AuthorsDataGridView_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles AuthorsDataGridView.CellContentClick
        If AuthorsDataGridView.Columns(e.ColumnIndex) Is ColBooks Then
            Dim DR = CType(AuthorsDataGridView.Rows(e.RowIndex).DataBoundItem, DataRowView)
            If DR Is Nothing Then Exit Sub
            FrmBooks.LbAuthor.Text = "كتب " & DR("Author") & ": "
            FrmBooks.DGAuthorBooks.DataSource = DR.CreateChildView("FK_Books_Authors")
            FrmBooks.ShowDialog()
        End If
    End Sub

    Private Sub LnkNext_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles LnkNext.LinkClicked
        Dim I = CurLink.Text
        If I = MaxLinks Then
            For Each Lnk In PageLinks
                Lnk.Text += MaxLinks
                If Lnk.Text > PagesNo Then Lnk.Visible = False
            Next
            FirstPageNo += MaxLinks
        End If
        LnkPage1_LinkClicked(PageLinks(I - FirstPageNo + 1), New LinkLabelLinkClickedEventArgs(Nothing))

    End Sub

    Private Sub LnkPrev_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles LnkPrev.LinkClicked
        Dim I = CurLink.Text
        If I = FirstPageNo Then
            For Each Lnk In PageLinks
                Lnk.Text -= MaxLinks
                Lnk.Visible = True
            Next
            FirstPageNo -= MaxLinks
        End If
        LnkPage1_LinkClicked(PageLinks(I - FirstPageNo - 1), New LinkLabelLinkClickedEventArgs(Nothing))

    End Sub
End Class
