﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        DAAuthors.Fill(DsAuthors, "Authors")
        DABooks.Fill(DsAuthors, "Books")
    End Sub

    Private Sub Tables(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnTables.Click
        ListBox1.Items.Clear()
        For Each tbl As DataTable In DsAuthors.Tables
            ListBox1.Items.Add(tbl.TableName)
        Next
    End Sub

    Private Sub Relations(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnRelations.Click
        ListBox2.Items.Clear()
        For Each rel As DataRelation In DsAuthors.Relations
            ListBox2.Items.Add(rel.RelationName)
        Next
    End Sub

    Private Sub SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox2.SelectedIndexChanged
        Dim rel As DataRelation = DsAuthors.Relations.Item(ListBox2.Text)
        If rel Is Nothing Then Exit Sub
        Dim msg As String
        msg = "الجدول الرئيسيّ: " & rel.ParentTable.TableName & vbCrLf
        msg &= "الجدول الفرعيّ: " & rel.ChildTable.TableName & vbCrLf
        msg &= rel.ParentColumns(0).ColumnName
        msg &= " = " & rel.ChildColumns(0).ColumnName
        MsgBox(msg)
    End Sub

    Private Sub Data(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnData.Click
        TreeView1.Nodes.Clear()
        Dim AuthorRelation As String = DsAuthors.Relations(0).RelationName

        For Each row As DsAuthorsBooks.AuthorsRow In DsAuthors.Authors
            Dim ANode As TreeNode = TreeView1.Nodes.Add(Trim(row.Author))
            Dim BooksRow() As DsAuthorsBooks.BooksRow = row.GetChildRows(AuthorRelation)
            For Each BRow As DsAuthorsBooks.BooksRow In BooksRow
                ANode.Nodes.Add(Trim(BRow.Book))
            Next
        Next
    End Sub
End Class