﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Imports System.Data.SqlClient
Imports System.IO


Public Class Form1
    
    Dim CnStr As String
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim CnStrBldr As New SqlConnectionStringBuilder
        CnStrBldr.DataSource = ".\SQLEXPRESS"
        CnStrBldr.AttachDBFilename = "C:\Books.mdf"
        CnStrBldr.IntegratedSecurity = True
        CnStr = CnStrBldr.ConnectionString
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ReadData("SELECT ID, Logo FROM Publishers")
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        ReadData("SELECT ID, Logo2 FROM Publishers")
    End Sub


    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        ReadData("SELECT ID, Logo3 FROM Publishers")
    End Sub

    Sub ReadData(ByVal SQL As String)
        Dim Cn As New SqlConnection(CnStr)
        Dim Cmd As New SqlCommand(SQL, Cn)

        Dim stream As FileStream
        Dim writer As BinaryWriter
        Dim bufferSize As Integer = 100
        Dim outByte(bufferSize - 1) As Byte
        Dim retval As Long
        Dim startIndex As Long = 0

        Dim pubID As Long = 0
        Cn.Open()
        Dim Dr As SqlDataReader = Cmd.ExecuteReader(CommandBehavior.SequentialAccess)

        Do While Dr.Read()
            ' يجب أن نقرأ رقم الناشر أولا قبل قراءة الصورة، لأننا نتعامل تتابعيا
            '  وسنستخدم هذا الرقم في تكوين اسم ملف الصورة
            pubID = Dr.GetValue(0)
            If Dr.IsDBNull(1) Then Continue Do

            startIndex = 0            
            retval = Dr.GetBytes(1, startIndex, outByte, 0, bufferSize)
            If retval < 5 Then Continue Do ' ليست صورة، بل بيانات افتراضية

            stream = New FileStream("C:\logo" & pubID & ".bmp", FileMode.OpenOrCreate, FileAccess.Write)
            writer = New BinaryWriter(stream)

            Do While retval = bufferSize
                writer.Write(outByte)
                writer.Flush()
                startIndex += bufferSize
                retval = Dr.GetBytes(1, startIndex, outByte, 0, bufferSize)
            Loop

            If retval > 0 Then
                ReDim Preserve outByte(retval - 1)
                writer.Write(outByte, 0, retval)
                writer.Flush()
            End If
            ' إعادة حجم مصفوفة القراءة إلى الوضع الافتراضي، لاستخدامها في اللفة التالية
            ReDim Preserve outByte(bufferSize - 1)

            writer.Close()
            stream.Close()
        Loop

        Dr.Close()
        Cn.Close()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        ' سنقرأ صورة أول ناشر مرة واحدة وليس تتابعيا
        Dim Cn As New SqlConnection(CnStr)
        Dim Cmd As New SqlCommand("SELECT Logo FROM Publishers", Cn)
        Cn.Open()
        Dim Dr As SqlDataReader = Cmd.ExecuteReader
        Dim Stream As New FileStream("C:\logo1.bmp", FileMode.OpenOrCreate, FileAccess.Write)
        Dim writer As New BinaryWriter(Stream)
        If Dr.Read() Then
            Dim Img As SqlTypes.SqlBinary = Dr.GetSqlBinary(0)
            writer.Write(Img.Value)
        End If
        Dr.Close()
        Cn.Close()
        writer.Close()
        Stream.Close()
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim SQL = "SELECT ID, Logo3.PathName()," &
                             " GET_FILESTREAM_TRANSACTION_CONTEXT () " &
                             " From Publishers"
        Using Cn As New SqlConnection(CnStr)
            Cn.Open()
            Dim Tran = Cn.BeginTransaction(IsolationLevel.ReadCommitted)
            Dim Cmd As New SqlCommand(SQL, Cn, Tran)
            Using reader As SqlDataReader = Cmd.ExecuteReader()
                Do While reader.Read()
                    Dim pubID As Long = reader(0)
                    ' إذا لم تكن هناك صورة محفوظة، فلا داعي لإكمال اللفة الحالية
                    If reader.IsDBNull(1) Then Continue Do

                    ' قراءة مسار ملف الصورة
                    Dim path As String = reader.GetString(1)
                    Dim transactionContext() As Byte = reader.GetSqlBytes(2).Buffer
                    ' إنشاء مجرى بيانات للتعامل مع الملف
                    Dim fileStream As New SqlTypes.SqlFileStream(path, transactionContext, FileAccess.Read, FileOptions.SequentialScan, 0)
                    '                    MsgBox(fileStream.Name)
                    Dim stream As FileStream
                    Dim writer As BinaryWriter
                    Dim bufferSize As Integer = 100
                    Dim outByte(bufferSize - 1) As Byte
                    Dim retval As Long

                    stream = New FileStream("C:\logo" & pubID & ".bmp", FileMode.OpenOrCreate, FileAccess.Write)
                    writer = New BinaryWriter(stream)

                    Do
                        retval = fileStream.Read(outByte, 0, bufferSize)
                        If retval < bufferSize Then
                            If retval <> 0 Then
                                ReDim Preserve outByte(retval - 1)
                                writer.Write(outByte)
                            End If
                            Exit Do
                        Else
                            writer.Write(outByte)
                        End If
                    Loop

                    writer.Close()
                    stream.Close()
                    fileStream.Close()
                Loop
                reader.Close()
                Tran.Commit()
            End Using

        End Using
    End Sub
End Class
