﻿'هذا المثال كتبه: محمد حمدي غانم.
'وهو أحد أمثلة كتاب: 
' من الصفر إلى الاحتراف، برمجة نماذج الويندوز في فيجيوال بيزيك دوت نت 2008
'الناشر: مكتبة دار المعرفة، 4 شارع السرايات ـ
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043، 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Public Class Form1

    Dim No As Integer = 0
    Private Sub BtAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtAdd.Click
        ' معرفة الفرع المحدد لإضافة العنصر الجديد بعده في نفس المستوى 
        Dim N As TreeNode = TreeView1.SelectedNode

        No += 1
        If N Is Nothing Then ' لا يوجد عنصر محدد، لهذا سنضيف العنصر الجديد كجذر للشجرة
            N = TreeView1.Nodes.Add("عنصر جديد" + Trim(No))
            TreeView1.SelectedNode = N
        Else
            Dim N1 As New TreeNode("عنصر جديد" + Trim(No))
            Dim PNode = N.Parent
            If PNode Is Nothing Then ' الفرع الحالي جذر للشجرة.. سنجعل الفرع الجديد جذرا أيضا
                TreeView1.Nodes.Insert(N.Index + 1, N1)
            Else ' سنضيف الفرع الجديد إلى الفرع الرئيسي للفرع الحالي
                PNode.Nodes.Insert(N.Index + 1, N1)
            End If
            TreeView1.SelectedNode = N1
        End If
    End Sub

    Private Sub BtRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtRemove.Click
        Dim N As TreeNode = TreeView1.SelectedNode
        If N Is Nothing Then ' لا يوجد عنصر محدد في الشجرة لحذفه 
            Beep()
            Exit Sub
        End If
        If MsgBox("هل أنت متأكد أنّك تريد حذف هذا العنصر؟.. لو كانت هناك عناصر فرعية فسيتم حذفها بدورها.", MsgBoxStyle.YesNo) = MsgBoxResult.No Then Exit Sub
        N.Remove() ' حذف العنصر الحالي
    End Sub

    Private Sub BtUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtUp.Click

        Dim N As TreeNode = TreeView1.SelectedNode
        If N Is Nothing Then ' لا يوجد عنصر محدد
            Beep()
            Exit Sub
        End If

        Dim ID As Integer = N.Index
        If ID = 0 Then ' لا يمكن تحريك اتلعنصر إلى أعلى لأنه أول عنصر
            Beep()
            Exit Sub
        End If

        Dim PNode = N.Parent
        N.Remove() ' حذف العنصر من موضعخ لإعادة إضافته في موضع آخر
        If PNode Is Nothing Then  ' العنصر جذر من جذور الشجرة
            TreeView1.Nodes.Insert(ID - 1, N)
        Else ' إعادة إضافة العنصر إلى نفس الفرع الذي يوجد به، لكمن في موضع آخر
            PNode.Nodes.Insert(ID - 1, N)
        End If

        TreeView1.SelectedNode = N ' تحديد العنصر
    End Sub

    Private Sub TreeView1_AfterLabelEdit(ByVal sender As Object, ByVal e As System.Windows.Forms.NodeLabelEditEventArgs) Handles TreeView1.AfterLabelEdit
        If e.Label = "" OrElse e.Label.Trim = "" Then
            Beep()
            e.CancelEdit = True
            Return
        End If
        EditTextChanged = True
        NodeText.Text = e.Label
    End Sub

    Private Sub TreeView1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TreeView1.KeyDown
        If e.KeyCode = Keys.Delete Then BtRemove.PerformClick()
    End Sub

    Private Sub BtDown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtDown.Click

        Dim N As TreeNode = TreeView1.SelectedNode
        If N Is Nothing Then  ' لا يوجد عنصر محدد
            Beep()
            Exit Sub
        End If

        If N.NextNode Is Nothing Then ' لا يمكن تحريك العنصر للأسفل لأنه آخر عنصر
            Beep()
            Exit Sub
        End If

        Dim ID = N.Index
        Dim PNode = N.Parent
        N.Remove() ' حذف العنصر من موضعخ لإعادة إضافته في موضع آخر
        If PNode Is Nothing Then  ' العنصر جذر من جذور الشجرة
            TreeView1.Nodes.Insert(ID + 1, N)
        Else
            PNode.Nodes.Insert(ID + 1, N)
        End If

        TreeView1.SelectedNode = N

    End Sub

    Private Sub BtOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtOut.Click

        Dim N As TreeNode = TreeView1.SelectedNode
        If N Is Nothing Then ' لا يوجد عنصر محدد
            Beep()
            Exit Sub
        End If

        Dim PNode = N.Parent
        If PNode Is Nothing Then ' العنصر جذر للشجرة، ولا يمكن رفع مستواه
            Beep()
            Exit Sub
        End If

        Dim ID = PNode.Index
        N.Remove() ' حذف العنصر لإضافته إلى مستوى أعلى من مستواه
        PNode = PNode.Parent ' إضافة العنصر إلى الفرع الرئيس لفرعه الرئيسي
        If PNode Is Nothing Then ' لا يوجد فرع رئيسي للفرع الرئيسي.. هذا معناه أننا وصلنا إلى مستوى الجذر
            TreeView1.Nodes.Insert(ID + 1, N)
        Else
            PNode.Nodes.Insert(ID + 1, N)
        End If
        TreeView1.SelectedNode = N
    End Sub

    Private Sub BtIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtIn.Click

        Dim N As TreeNode = TreeView1.SelectedNode

        If N Is Nothing Then ' لا يوجد عنصر محدد
            Beep()
            Exit Sub
        End If

        Dim PNode = N.PrevNode ' سنجعل العنصر الحالي عنصرا فرعيا للعنصر السابق له

        If PNode Is Nothing Then ' لا يوجد عنصر سابق.. العملية غر ممكنة
            Beep()
            Exit Sub
        End If

        N.Remove()
        PNode.Nodes.Add(N)

        TreeView1.SelectedNode = N
    End Sub

    Dim EditTextChanged As Boolean = False
    Private Sub NodeText_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NodeText.TextChanged
        If EditTextChanged Then
            EditTextChanged = False
            Exit Sub
        End If
        Try
            TreeView1.SelectedNode.Text = NodeText.Text
        Catch
            Beep()
        End Try
    End Sub

    Private Sub TreeView1_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TreeView1.AfterSelect
        EditTextChanged = True
        NodeText.Text = e.Node.Text
    End Sub

  
    Private Sub BtClone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtClone.Click
        Dim CurNode = TreeView1.SelectedNode
        If CurNode Is Nothing Then
            Beep()
            Exit Sub
        End If
        Dim NewNode As TreeNode = CurNode.Clone
        TreeView1.Nodes.Add(NewNode)
        TreeView1.SelectedNode = NewNode
        NewNode.ExpandAll()
    End Sub

    Private Sub BtSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtSave.Click
        TreeDs.Clear()
        For Each Node As TreeNode In TreeView1.Nodes
            Dim R = TreeDs.TreeNodes.AddTreeNodesRow(Node.Text, Nothing)
            SaveChildren(Node, R)
        Next
        TreeDs.WriteXml("C:\TreeNodes.Xml")
    End Sub

    Sub SaveChildren(ByVal ParentNode As TreeNode, ByVal ParentRow As TreeDataSet.TreeNodesRow)
        For Each Node As TreeNode In ParentNode.Nodes
            Dim R = TreeDs.TreeNodes.AddTreeNodesRow(Node.Text, ParentRow)
            SaveChildren(Node, R)
        Next
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        TreeDs.Clear()
        TreeDs.ReadXml("C:\TreeNodes.Xml")
        TreeView1.Nodes.Clear()
        For Each R In TreeDs.TreeNodes
            If R.IsParentIDNull Then
                Dim Node = TreeView1.Nodes.Add(R.Text)
                LoadChildren(Node, R)
            End If
        Next


    End Sub

    Sub LoadChildren(ByVal ParentNode As TreeNode, ByVal ParentRow As TreeDataSet.TreeNodesRow)        
        For Each R As TreeDataSet.TreeNodesRow In ParentRow.GetChildRows("Self_Relation")
            Dim Node = ParentNode.Nodes.Add(R.Text)
            LoadChildren(Node, R)
        Next
    End Sub
End Class
