﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Imports System.Data.SqlClient
Imports System.IO
Public Class Form1


    Dim CnStr As String
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim CnStrBldr As New SqlConnectionStringBuilder
        CnStrBldr.DataSource = ".\SQLEXPRESS"
        CnStrBldr.AttachDBFilename = "C:\Books.mdf"
        CnStrBldr.IntegratedSecurity = True
        CnStr = CnStrBldr.ConnectionString
    End Sub
    
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim UpdateQuery As String =
             "UPDATE Publishers " &
             " SET Logo =  @Logo " &
             " WHERE ID = 1 "
        AddLogo(UpdateQuery)
    End Sub

    Sub AddLogo(ByVal Sql As String)
        Dim Cn As New SqlConnection(CnStr)

        Dim LogoPrarm As New SqlParameter("@Logo", SqlDbType.Image)
        Dim Cmd As New SqlCommand(Sql, Cn)
        Cmd.Parameters.Add(LogoPrarm)

        Dim Ofd As New OpenFileDialog
        Ofd.Title = "اختر شعار الناشر الأول"
        Ofd.Filter = "Image|*.bmp;*.gif;*.jpg"
        If Ofd.ShowDialog = Windows.Forms.DialogResult.OK Then
            Dim Fs = Ofd.OpenFile
            If Fs.Length = 0 Then
                MsgBox("هذه الصورة غير صالحة لأن حجمها صفر")
                Exit Sub
            End If

            Try
                Cn.Open()
                Dim B(Fs.Length - 1) As Byte
                Fs.Read(B, 0, Fs.Length)
                LogoPrarm.Value = B
                Cmd.ExecuteNonQuery()
            Catch ex As Exception
                MsgBox(ex.Message)
            Finally
                Cn.Close()
            End Try

        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' سنضع صورة شعار للناشر الثاني
        Dim Cn As New SqlConnection(CnStr)
        Dim Update As String =
                 "UPDATE Publishers " &
                 " SET Logo2  .WRITE (@Logo, @Offset , @Length)  " &
                 " WHERE ID = 2"

        Dim LogoPrarm As New SqlParameter("@Logo", SqlDbType.VarBinary)
        Dim OffsetPrarm As New SqlParameter("@Offset", SqlDbType.Int)
        Dim LengthPrarm As New SqlParameter("@Length", SqlDbType.Int)

        Dim Cmd As New SqlCommand(Update, Cn)
        Cmd.Parameters.AddRange({LogoPrarm, OffsetPrarm, LengthPrarm})

        Dim Ofd As New OpenFileDialog
        Ofd.Title = "اختر شعار الناشر الأول"
        Ofd.Filter = "Image|*.bmp;*.gif;*.jpg"
        If Ofd.ShowDialog = Windows.Forms.DialogResult.OK Then
            Dim Fs = Ofd.OpenFile
            Dim FileLen = Fs.Length
            If FileLen = 0 Then
                MsgBox("هذه الصورة غير صالحة لأن حجمها صفر")
                Exit Sub
            End If

            Dim B(FileLen - 1) As Byte
            Fs.Read(B, 0, FileLen)
            Dim DataSize = 100
            LogoPrarm.Offset = 0
            OffsetPrarm.Value = 0
            LogoPrarm.Value = B

            Try
                Cn.Open()

                Dim NoOfBytes As Integer = DataSize
                Do
                    LogoPrarm.Size = Math.Min(DataSize, FileLen - LogoPrarm.Offset)
                    LengthPrarm.Value = LogoPrarm.Size

                    Cmd.ExecuteNonQuery()
                    LogoPrarm.Offset += LogoPrarm.Size
                    OffsetPrarm.Value = LogoPrarm.Offset
                Loop While LogoPrarm.Offset < FileLen

            Catch ex As Exception
                MsgBox(ex.Message)
            Finally
                Cn.Close()
            End Try

        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        ' Logo نظرا لأن العمود
        'image نوعه 
        ' Logo2 فسنضيف الصورة بالطريقة الجديدة إلى العمود
        ' varbinary(MAX) لأن نوع 

        Dim Cn As New SqlConnection(CnStr)
        Dim Update As String =
                 "UPDATE Publishers " &
                 " SET Logo2  .WRITE (@Logo, @Offset , @Length)  " &
                 " WHERE ID = 1 "

        Dim LogoPrarm As New SqlParameter("@Logo", SqlDbType.VarBinary)
        Dim OffsetPrarm As New SqlParameter("@Offset", SqlDbType.Int)
        Dim LengthPrarm As New SqlParameter("@Length", SqlDbType.Int)

        Dim Cmd As New SqlCommand(Update, Cn)
        Cmd.Parameters.AddRange({LogoPrarm, OffsetPrarm, LengthPrarm})

        Dim Ofd As New OpenFileDialog
        Ofd.Title = "اختر شعار الناشر الأول"
        Ofd.Filter = "Image|*.bmp;*.gif;*.jpg"
        If Ofd.ShowDialog = Windows.Forms.DialogResult.OK Then
            Dim Fs = Ofd.OpenFile
            If Fs.Length = 0 Then
                MsgBox("هذه الصورة غير صالحة لأن حجمها صفر")
                Exit Sub
            End If

            Try
                Cn.Open()
                Dim DataSize As Integer = 100
                Dim NoOfBytes As Integer = DataSize
                LengthPrarm.Value = DataSize
                OffsetPrarm.Value = 0
                Do
                    Dim B(DataSize - 1) As Byte
                    NoOfBytes = Fs.Read(B, 0, DataSize)
                    LengthPrarm.Value = NoOfBytes
                    If NoOfBytes < DataSize Then ReDim Preserve B(NoOfBytes)
                    LogoPrarm.Value = B
                    Cmd.ExecuteNonQuery()
                    OffsetPrarm.Value += NoOfBytes
                Loop Until NoOfBytes < DataSize

            Catch ex As Exception
                MsgBox(ex.Message)
            Finally
                Cn.Close()
            End Try

        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        ' هذا الكود سيؤدي إلى خطأ ولن يمكنك تنفيذه
        ' لأن الاستعلام خاطئ، ولا يمكن الإضافة إلى البيانات الثنائية بهذه الطريقة

        Dim Cn As New SqlConnection(CnStr)
        Dim Update As String =
                 "UPDATE Publishers " &
                 " SET Logo = Logo + @Logo " &
                 " WHERE ID = 1 "

        Dim LogoPrarm As New SqlParameter("@Logo", SqlDbType.Image)
        Dim Cmd As New SqlCommand(Update, Cn)
        Cmd.Parameters.Add(LogoPrarm)

        Dim Ofd As New OpenFileDialog
        Ofd.Title = "اختر شعار الناشر الأول"
        Ofd.Filter = "Image|*.bmp;*.gif;*.jpg"
        If Ofd.ShowDialog = Windows.Forms.DialogResult.OK Then
            Dim Fs = Ofd.OpenFile
            If Fs.Length = 0 Then
                MsgBox("هذه الصورة غير صالحة لأن حجمها صفر")
                Exit Sub
            End If

            Try
                Cn.Open()
                Dim DataSize = 100
                Dim NoOfBytes As Integer = DataSize
                Do
                    Dim B(99) As Byte
                    NoOfBytes = Fs.Read(B, 0, DataSize)
                    LogoPrarm.Value = B
                    Cmd.ExecuteNonQuery()
                Loop Until NoOfBytes < DataSize

            Catch ex As Exception
                MsgBox(ex.Message)
            Finally
                Cn.Close()
            End Try

        End If
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim UpdateQuery As String =
                 "UPDATE Publishers " &
                  " SET Logo3 =  @Logo " &
                  " WHERE ID = 1 "
        AddLogo(UpdateQuery)
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim SQL = "UPDATE Publishers" &
                            " SET Logo3 = 0x0" &
                            " Where ID = 2;" &
                            "SELECT Logo3.PathName()," &
                            " GET_FILESTREAM_TRANSACTION_CONTEXT () " &
                            " From Publishers Where ID = 2"
        Dim Ofd As New OpenFileDialog
        Ofd.Title = "اختر شعار الناشر الأول"
        Ofd.Filter = "Image|*.bmp;*.gif;*.jpg"
        If Ofd.ShowDialog <> Windows.Forms.DialogResult.OK Then Exit Sub
        Dim Fs = Ofd.OpenFile
        If Fs.Length = 0 Then
            MsgBox("هذه الصورة غير صالحة لأن حجمها صفر")
            Exit Sub
        End If

        Using Cn As New SqlConnection(CnStr)
            Cn.Open()
            Dim Tran = Cn.BeginTransaction()
            Dim Cmd As New SqlCommand(SQL, Cn, Tran)
            Using reader As SqlDataReader = Cmd.ExecuteReader()
                If reader.Read() Then
                    ' قراءة مسار ملف الصورة
                    Dim path As String = reader(0)
                    Dim transactionContext() As Byte = reader.GetSqlBytes(1).Buffer
                    ' إنشاء مجرى بيانات للتعامل مع الملف
                    Dim fileStream As New SqlTypes.SqlFileStream(path, transactionContext, FileAccess.Write, FileOptions.SequentialScan, 0)

                    Dim bufferSize As Integer = 100
                    Dim outByte(bufferSize - 1) As Byte
                    Dim retval As Long

                    Do
                        retval = Fs.Read(outByte, 0, bufferSize)
                        If retval < bufferSize Then
                            If retval <> 0 Then
                                ReDim Preserve outByte(retval - 1)
                                fileStream.Write(outByte, 0, retval)
                            End If
                            Exit Do
                        Else
                            fileStream.Write(outByte, 0, bufferSize)
                        End If
                    Loop

                    Fs.Close()
                    fileStream.Close()
                End If
                reader.Close()
                Tran.Commit()
            End Using

        End Using
    End Sub
End Class
